﻿//----------------------------------------------------------------------------
// Atlasmaker
// AtlasPacker.jsx - rectangle packer for Atlasmaker
// This just wraps Ivan Montes' RectanglePacker.js so it can be used in
// Atlasmaker
//
// Author: Richard Dare
// richardjdare@googlemail.com
// http://richardjdare.com 
//----------------------------------------------------------------------------

#include "Packer.jsx"
#include "ImageInfo.jsx"
#include "RectanglePacker.js"

// make it inherit from Packer
AtlasPacker.prototype = new Packer;
AtlasPacker.prototype.constructor = AtlasPacker;

//override data members
AtlasPacker.prototype.name = "Texture Atlas";
AtlasPacker.prototype.allowsRotation = false;

//----------------------------------------------------------------------------
// Constructor
//----------------------------------------------------------------------------
function AtlasPacker(){
	this.docWidth = 0;
	this.docHeight= 0;
	this.docCols = 0;
	this.docRows = 0;
    
    //----------------------------------------------------------------------------
    // CalcAtlas
    //----------------------------------------------------------------------------
    this.CalcAtlas = function(currentPage,sourceFiles){

        var nofit = 0;
        var packer = new NETXUS.RectanglePacker(this.docWidth, this.docHeight);
		
        for(var i=0;i<sourceFiles.length;i++)
        {
            var coords;
            var sourceImage = sourceFiles[i];

            if(!sourceImage.imagePlaced)
            {
                // rjd: calculate the margin: we put <docMargin> pixels on each side,like css margins.
                var m = this.margin * 2;

                // find out where to put the image...
                coords = packer.findCoords(sourceImage.width+m,sourceImage.height+m);
                if(coords)
                {
                    sourceImage.posX = coords.x;
                    sourceImage.posY = coords.y;
                    sourceImage.imagePlaced=true;
                    sourceImage.pageIndex = currentPage;
                }
                else
                {
                    nofit++;
                }
            }
        }
        return nofit;
    };
};

//----------------------------------------------------------------------------
// Init() - called when this packer is selected
//----------------------------------------------------------------------------
AtlasPacker.prototype.Init = function(width,height){
	this.docWidth = width;
	this.docHeight= height;
	this.docCols = 0;
	this.docRows = 0; 
};

//----------------------------------------------------------------------------
// Calculate() - make the atlas
//----------------------------------------------------------------------------
AtlasPacker.prototype.Calculate = function(srcImages){
    
    var imagesToPack = srcImages.length;
    var page=0;
 
	while(imagesToPack>0)
	{	
        imagesToPack = this.CalcAtlas(page++,srcImages);
	}
    
	return true;
};


