﻿//----------------------------------------------------------------------------
// AtlasMaker
// Packer.js - Base class for an AtlasMaker Packing techniques.
//
// Author: Richard Dare
// richardjdare@googlemail.com
// http://richardjdare.com 
//----------------------------------------------------------------------------

function Packer(){};

// All packers must have a name. It's used in the main ui dropdown
Packer.prototype.name = "Undefined Packer";

// Does this packer rotate sprites? NOTE: rotation not implemented yet!
Packer.prototype.allowsRotation = false;

// Does the user want to rotate sprites?
// AtlasMaker will set this variable before running the packer.
Packer.prototype.usingRotation = false;

// width and height of atlas image.
Packer.prototype.atlasWidth = 0;
Packer.prototype.atlasHeight= 0;

// margin around each image.
// when images are passed to ONLINE packers, the margin is already added on.
// you only worry about this when writing OFFLINE packers.
Packer.prototype.margin = 0;

// this is used to report error messages to AtlasMaker.
Packer.prototype.errorFlag = false;

// this is an array of strings containing any error messages your packer
// wants to report.
Packer.prototype.errorMessages =[];

// the application will display a custom string for the packer at the top
// of the ui. Use this to present information to the user.
Packer.prototype.statusMessage = "";

//----------------------------------------------------------------------------
// Init() - AtlasMaker calls this when your packer is selected
// from the ui, before running the packer itself.
// Parameters: width  - user selected width of atlas
//             height - user selected height of atlas
//----------------------------------------------------------------------------
Packer.prototype.Init = function(width,height){return null;};

//----------------------------------------------------------------------------
// Calculate() - Perform texture atlas calculation.
// Parameters: allImages - an array of ImageInfo objects
//----------------------------------------------------------------------------
Packer.prototype.Calculate = function(allImages){return null;};

//----------------------------------------------------------------------------
// ClearErrors()
//----------------------------------------------------------------------------
Packer.prototype.ClearErrors = function(){errors =[];errorFlag = false};
